﻿Imports System.Text.RegularExpressions

Public Class Paint
    Private _b As Brush
    Private _c As Canvas
    Private _ps As Point
    Private _l As Log
    Private _pf As Boolean

    Public Property g() As Graphics
        Get
            Return _c.g
        End Get
        Set(ByVal value As Graphics)
            _c.g = value
        End Set
    End Property

    Public Property b() As Bitmap
        Get
            Return _c.b
        End Get
        Set(ByVal value As Bitmap)
            _c.b = value
        End Set
    End Property

    Public Sub Play()
        Dim e As String
        Dim i As Integer = 0
        e = _l.GetEntry(i)
        Do Until e = ""
            e = _l.GetEntry(i)

            Debug.Print(e)
            Dim p()
            p = Split(e, ",", 2)

            'Paint.Move,{X=603,Y=152},234
            'Paint.Down,{X=609,Y=142}
            'Paint.Up,{X=578,Y=196}
            _pf = False
            Select Case p(0)
                Case "Paint.Move"
                    Dim c1 As GroupCollection = Regex.Match(p(1), "{X=([0-9]+),Y=([0-9]+)},([0-9]+)").Groups
                    Move(New Point(Integer.Parse(c1(1).Value), Integer.Parse(c1(2).Value)), Integer.Parse(c1(3).Value))
                Case "Paint.Down"
                    Dim c1 As GroupCollection = Regex.Match(p(1), "{X=([0-9]+),Y=([0-9]+)}").Groups
                    Down(New Point(Integer.Parse(c1(1).Value), Integer.Parse(c1(2).Value)))
                Case "Paint.Up"
                    Dim c1 As GroupCollection = Regex.Match(p(1), "{X=([0-9]+),Y=([0-9]+)}").Groups
                    Up(New Point(Integer.Parse(c1(1).Value), Integer.Parse(c1(2).Value)))
            End Select
            _pf = True
            Form1.RefreshImage() '***
            Application.DoEvents() '***

            i = i + 1
        Loop
    End Sub

    Public Sub SaveCanvas()
        MessageBox.Show(_c.Save())
    End Sub

    Public Sub ClearLayer()
        _c.ClearLayer()
    End Sub

    Public Sub CreateLayer()
        _c.CreateLayer()
    End Sub

    Public Sub CreateImage(ByVal width As Integer, ByVal height As Integer)
        _c = New Canvas(width, height)
    End Sub

    Public Sub Down(ByVal pt As Point)
        _ps = pt
        If _pf Then _l.AddEntry("Paint.Down," & pt.ToString())
    End Sub

    Public Sub Move(ByVal pt As Point, ByVal pr As Integer)
        Static w_ As Integer = 0
        Dim w As Integer
        If Not _ps.IsEmpty AndAlso Not pt.IsEmpty AndAlso pr > 0 Then
            w = pr / 10
            w_ = w
            w = Math.Min(Math.Max(w, w_ * 0.9), w_ * 1.1)
            w = Math.Min(Math.Max(w, 2), 100)
            _b.w = w
            _c.Draw(_b, _ps, pt)
            _ps = pt
            If _pf Then _l.AddEntry("Paint.Move," & pt.ToString() & "," & pr.ToString())
        End If
    End Sub

    Public Sub Up(ByVal pt As Point)
        _ps = Point.Empty
        If _pf Then _l.AddEntry("Paint.Up," & pt.ToString)
    End Sub

    Public Sub New(ByVal width As Integer, ByVal height As Integer)
        _b = New Brush()
        CreateImage(width, height)
        _c.g = g
        _pf = True
        _l = New Log()
    End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub
End Class
